#ifndef __USTCLIB_HPP__
#define __USTCLIB_HPP__
#include <sys/types.h>			/* */
#include <stdio.h>			/* */
/*
License agreement:
USTCLIB 0.1 (c) 2006-2010 Dmitriy I.Cherkashin, www.ucrouter.ru
email: dch@ucrouter.ru , divch@users.sourceforge.net , dch@ucrouter.com
phone: +8-909-936-8809; ICQ: 474-363-900;
This program is free software with source codes
downloadable via internation communicational net.
If you have source codes of this software original or modified,
you must provide ability to free receive original source codes
of this software to another users even in internation communicational
net absense without any unusual additional payment exept
downloading files from internation communicational net cost or
mail cost.
*/
/*
 ,  : 
USTCLIB 0.1 (c) 2006-2010  ., www.ucrouter.ru
 : dch@ucrouter.ru,divch@users.sourceforge.net,dch@ucrouter.com
: +8-909-936-8809; ICQ: 474-363-900;
     
      
 .
       
  ,     
     
     
      
       
    
     .
*/
extern u_int8_t ustc_nl_print;
typedef struct {			/* KICAD LIB header definition */
    u_int8_t * header;			/* kicad lib header buffer */
    u_int8_t versionhi;			/* kicad lib version hi number */
    u_int8_t versionlo;			/* kicad lib version lo number */
    u_int8_t day;			/* month day */
    u_int8_t mon;			/* month */
    u_int16_t year;			/* year */
    u_int8_t hour;			/* hour */
    u_int8_t min;			/* minute */
    u_int8_t sec;			/* second */
} USTC_LIB_HEADER;
extern USTC_LIB_HEADER ustc_lib_header;
typedef struct {			/* typedef */
    u_int8_t * name;			/* alias name pointer */
} USTC_LIB_ALIAS;			/* kicad lib alias */
extern USTC_LIB_ALIAS * ustc_lib_alias;	/* kicad lib alias pointer */
extern u_int32_t ustc_lib_alias_count;	/* kicad lib alias count */
typedef struct {
    u_int8_t * name;			/* text name */
    int32_t x0;				/* x position, mills */
    int32_t y0;				/* y position, mills */
    u_int16_t height;			/* text height */
    u_int8_t ornt;				/* field orientation */
#define USTC_LIB_FIELD_ORNT_UNKNOWN 0 	/* unknown orientation */
#define USTC_LIB_FIELD_ORNT_HOR     1 	/* orientation horizontal */
#define USTC_LIB_FIELD_ORNT_VERT    2 	/* orientation vertical */
    int8_t vis;				/* field visible */
    u_int8_t hor;			/* horizontal justify */
#define USTC_LIB_FIELD_HOR_UNKNOWN  0 	/* horizontal justify unknown */
#define USTC_LIB_FIELD_HOR_L 	    1	/* horizontal justify left */
#define USTC_LIB_FIELD_HOR_C 	    2	/* horizontal justify center */
#define USTC_LIB_FIELD_HOR_R 	    3	/* horizontal justify right */
    u_int8_t vert;			/* vertical justify unknown */	
#define USTC_LIB_FIELD_VERT_UNKNOWN 0 	/* vertical justify unknown */
#define USTC_LIB_FIELD_VERT_B 	   1	/* vertical justify bottom */
#define USTC_LIB_FIELD_VERT_C 	   2	/* vertical justify center */
#define USTC_LIB_FIELD_VERT_T 	   3	/* vertical justify top */
} USTC_LIB_FIELD;			/* kicad lib field */
extern USTC_LIB_FIELD * ustc_lib_field;	/* kicad lib field buffer pointer */
extern u_int32_t ustc_lib_field_count;	/* kicad lib field count */
typedef struct {
    int32_t x0;				/* x point, point count for 0 poly item */
    int32_t y0;				/* y point, poly fill for 0 poly item */
#define USTC_LIB_POLY_FILL_NO      0
#define USTC_LIB_POLY_FILL_DC      1
#define USTC_LIB_POLY_FILL_FILL    2
#define USTC_LIB_POLY_FILL_YES     3
#define USTC_LIB_POLY_FILL_UNKNOWN 4
} USTC_LIB_POLY;
extern USTC_LIB_POLY * ustc_lib_poly;	/* kicad lib point buffer */
extern u_int32_t ustc_lib_poly_count;	/* kicad lib point count */
typedef struct {
    int32_t x0;				/* x0 point */
    int32_t y0;				/* y0 point */
    int32_t x1;				/* x0 point */
    int32_t y1;				/* y0 point */
    int8_t fill;			/* rect filling */
} USTC_LIB_RECT;			/* kicad lib rectangle */
extern USTC_LIB_RECT * ustc_lib_rect;	/* kicad lib rect buffer */
extern u_int32_t ustc_lib_rect_count;	/* kicad lib rect count */
typedef struct {
    int32_t x0;				/* x0 point */
    int32_t y0;				/* y0 point */
    int32_t rad;			/* ring radius */
    int8_t fill;			/* rect filling */
#define USTC_LIB_RING_FILL_NO       0
#define USTC_LIB_RING_FILL_FILL     1
#define USTC_LIB_RING_FILL_YES      2
#define USTC_LIB_RING_FILL_UNKNOWN  3
} USTC_LIB_RING;			/* kicad lib ring definition */
extern USTC_LIB_RING * ustc_lib_ring;	/* kicad lib ring buffer pointer */
extern u_int32_t ustc_lib_ring_count;	/* kicad lib ring count */
typedef struct {
    int32_t x0;				/* x0 point */
    int32_t y0;				/* y0 point */
    int32_t rad;			/* radius */
    int16_t start;			/* start angle */
    int16_t end;			/* end angle */
    int32_t xs;				/* x start */
    int32_t ys;				/* y start */
    int32_t xe;				/* x end */
    int32_t ye;				/* y end */
    u_int8_t fill;
#define USTC_LIB_ARC_FILL_UNKNOWN 0
#define USTC_LIB_ARC_FILL_FILL    1
#define USTC_LIB_ARC_FILL_NO      2
} USTC_LIB_ARC;				/* kicad lib arc definition */
extern USTC_LIB_ARC * ustc_lib_arc;	/* kicad lib arc buffer pointer */
extern u_int32_t ustc_lib_arc_count;	/* kicad lib arc count */
typedef struct {
    u_int8_t ornt;			/* orientation */
#define USTC_LIB_TEXT_ORNT_UNKNOWN  0 	/* orientation unknown */
#define USTC_LIB_TEXT_ORNT_HOR      1 	/* orientation horizontal */
#define USTC_LIB_TEXT_ORNT_VERT     2 	/* orientation vertical */
    int32_t x0;				/* x point */
    int32_t y0;				/* y point */
    u_int16_t height;			/* text height */
    u_int8_t unused;
    u_int8_t * text;			/* text */
} USTC_LIB_TEXT;			/* kicad lib text definnition */
extern USTC_LIB_TEXT * ustc_lib_text;	/* kicad lib text buffer */
extern u_int32_t ustc_lib_text_count;	/* kicad lib text count */
typedef struct {
    u_int8_t type;			/* draw segment type */
#define USTC_LIB_DRAW_UNKNOWN  0	/* draw segment unknown */
#define USTC_LIB_DRAW_POLY     1	/* poly */ 
#define USTC_LIB_DRAW_RECT     2	/* rectangle */
#define USTC_LIB_DRAW_ARC      3	/* arc */
#define USTC_LIB_DRAW_RING     4	/* ring */
#define USTC_LIB_DRAW_TEXT     5	/* text */
    u_int8_t unit;			/* 0 - common in all parts, else part number */
    u_int8_t convert;			/* 0 - common in 2 representations, else 1 or 2 */
    int32_t width; 			/* line width */
    u_int32_t ref; 			/* draw reference */
} USTC_LIB_DRAW;			/* kicad lib draw definition */
extern USTC_LIB_DRAW * ustc_lib_draw;	/* kicad draw buffer */
extern u_int32_t ustc_lib_draw_count;	/* kicad draw count */
typedef struct {
    u_int8_t * name;			/* pin name */
    u_int32_t num;			/* pin number */
    int32_t x0;				/* x position */
    int32_t y0;				/* y position */
    int32_t length;			/* pin length */
    u_int8_t ornt;			/* pin orientation */
#define USTC_LIB_PIN_ORNT_UNKNOWN 0 	/* orientation unknown */
#define USTC_LIB_PIN_ORNT_UP      1  	/* orientation up */
#define USTC_LIB_PIN_ORNT_DOWN    2 	/* orientation down */
#define USTC_LIB_PIN_ORNT_RIGHT   3 	/* orientation right */
#define USTC_LIB_PIN_ORNT_LEFT    4 	/* orientation left */
    u_int16_t numheight;		/* hunber height */
    u_int16_t nameheight;		/* name height */
    u_int8_t unit;			/* part count */
    u_int8_t convert;			/* 0 - common in 2 representations, else 1 or 2 */
    u_int8_t etype;			/* e type */
#define USTC_LIB_PIN_ETYPE_INPUT          'I' /* input */
#define USTC_LIB_PIN_ETYPE_OUTPUT         'O' /* output */
#define USTC_LIB_PIN_ETYPE_BIDI           'B' /* bidirectional */
#define USTC_LIB_PIN_ETYPE_TRISTATE       'T' /* tristate */
#define USTC_LIB_PIN_ETYPE_PASSIVE        'P' /* passive */
#define USTC_LIB_PIN_ETYPE_UNSPECIFIED    'U' /* unspecified */
#define USTC_LIB_PIN_ETYPE_POWER_IN       'W' /* power in */
#define USTC_LIB_PIN_ETYPE_POWER_OUT      'w' /* power out */
#define USTC_LIB_PIN_ETYPE_OPEN_COLLECTOR 'C' /* open collector */
#define USTC_LIB_PIN_ETYPE_OPEN_EMITOR    'E' /* open emitor */
    u_int16_t shape;			/* shape, two characters */
#define USTC_LIB_PIN_SHAPE_LINE            0
#define USTC_LIB_PIN_SHAPE_INVERT         'I'
#define USTC_LIB_PIN_SHAPE_CLOCK          'C'
#define USTC_LIB_PIN_SHAPE_CLOCK_INV     ('I' | ('C' << 8))
#define USTC_LIB_PIN_SHAPE_LOW_IN         'L'
#define USTC_LIB_PIN_SHAPE_LOW_CLOCK     ('L' | ('C' << 8))
#define USTC_LIB_PIN_SHAPE_LOW_OUT        'V'
} USTC_LIB_PIN;				/* cad pin definition */
extern USTC_LIB_PIN * ustc_lib_pin;	/* cad pin buffer pointer */
extern u_int32_t ustc_lib_pin_count;	/* cad pin count */
typedef struct {
    u_int8_t * name;			/* name */
    u_int8_t * reference;		/* reference */
    u_int8_t unused;			/* unused */
    int32_t offset;			/* offset */
    u_int8_t pinnumvis;			/* pin number visible */
    u_int8_t pinnamvis;			/* pin name visible */
    u_int8_t units;			/* units */
    u_int8_t unitlock;			/* unit lock or swap disable */
#define USTC_LIB_COMP_UNITLOCK_FIXOLD 0 /* unit fix old format */
#define USTC_LIB_COMP_UNITLOCK_LOCK   1 /* unit lock */
#define USTC_LIB_COMP_UNITLOCK_FIX    2 /* unit fix */
    u_int8_t power;			/* power */
    u_int32_t alias;			/* alias reference */
    u_int32_t alcount;			/* alias count */
    u_int32_t ref;			/* field reference */
    u_int32_t val;			/* field value */
    u_int32_t pcb;			/* field pcb footprint */
    u_int32_t diagram;			/* field diagram */
    u_int32_t field;			/* field reference */
    u_int32_t fcount;			/* field count */
    u_int32_t draw;			/* draw reference */
    u_int32_t dcount;			/* draw count */
    u_int32_t pin;			/* pin reference */
    u_int32_t pcount;			/* pin count */
} USTC_LIB_COMP;			/* kicad lib component definition */
extern USTC_LIB_COMP * ustc_lib_comp;	/* kicad lib component buffer */
extern u_int32_t ustc_lib_comp_count;	/* kicad lib component count */
extern int ustc_lib_header_clear(USTC_LIB_HEADER * uli); /* lib header clear */
extern int ustc_lib_alias_clear(USTC_LIB_ALIAS * ulai);	/* lib alias clear */
extern int ustc_lib_field_clear(USTC_LIB_FIELD * ulfi);	/* lib field clear */
extern int ustc_lib_poly_clear(USTC_LIB_POLY * ulpi);	/* lib poly clear */
extern int ustc_lib_rect_clear(USTC_LIB_RECT * ulri);	/* lib rect clear */
extern int ustc_lib_ring_clear(USTC_LIB_RING * ulri);	/* lib ring clear */
extern int ustc_lib_arc_clear(USTC_LIB_ARC * ulai); /* kicad lib arc clear */	
extern int ustc_lib_text_clear(USTC_LIB_TEXT * ulti); /* kicad lib text clear */
extern int ustc_lib_draw_clear(USTC_LIB_DRAW * uldi);	/* lib draw clear */
extern int ustc_lib_pin_clear(USTC_LIB_PIN * ulpi);	/* kicad lib pin clear */
extern int ustc_lib_comp_clear(USTC_LIB_COMP * ulci);	/* kicad lib comp clear */
extern int ustc_lib_header_print(USTC_LIB_HEADER * uli); /* lib header print */
extern int ustc_lib_alias_print(USTC_LIB_ALIAS * ulai, u_int32_t count);
extern int ustc_lib_field_print(u_int32_t fnum, USTC_LIB_FIELD * ulfi);
extern int ustc_lib_poly_print(USTC_LIB_POLY * ulpi, u_int32_t count);
extern int ustc_lib_draw_print(USTC_LIB_DRAW * uldi);
extern int ustc_lib_pin_print(USTC_LIB_PIN * ulpi); /* kicad lib print */
extern int ustc_lib_comp_print(USTC_LIB_COMP * ulci); /* kicad lib print */
extern int ustc_lib_comps_print(u_int32_t crnum);
extern int ustc_lib_header_free(USTC_LIB_HEADER * uli);
extern int ustc_lib_header_read(USTC_LIB_HEADER * uli,u_int8_t * buf, u_int32_t size); /* lib header read */
extern int ustc_lib_alias_alloc(u_int32_t count); /* allocate kicad lib alias */
extern int ustc_lib_field_alloc(u_int32_t count); /* allocate kicad lib field */
extern int ustc_lib_poly_alloc(u_int32_t count); /* allocate kicad lib poly */
extern int ustc_lib_rect_alloc(u_int32_t count); /* allocate kicad lib rect */
extern int ustc_lib_ring_alloc(u_int32_t count); /* allocate kicad lib ring */
extern int ustc_lib_arc_alloc(u_int32_t count); /* allocate kicad lib arc */
extern int ustc_lib_text_alloc(u_int32_t count); /* allocate kicad lib text */
extern int ustc_lib_draw_alloc(u_int32_t count); /* allocate kicad lib draw */
extern int ustc_lib_pin_alloc(u_int32_t count); /* allocate kicad lib pin */
extern int ustc_lib_comp_alloc(u_int32_t count); /* allocate kicad lib comp */
extern int ustc_lib_comp_num(u_int8_t * name);
extern int ustc_lib_alias_free(void);		/* free cad alias */
extern int ustc_lib_field_free(void);		/* free lib field */
extern int ustc_lib_poly_free(void);		/* free lib poly */
extern int ustc_lib_rect_free(void);		/* free lib rect */
extern int ustc_lib_ring_free(void);		/* free lib ring */
extern int ustc_lib_arc_free(void);		/* free lib arc */
extern int ustc_lib_text_free(void);		/* free lib text */
extern int ustc_lib_draw_free(void);		/* free lib draw */
extern int ustc_lib_pin_free(void);		/* free lib pins */
extern int ustc_lib_comp_free(void);		/* free lib comp */
extern int ustc_lib_alias_add(u_int32_t *alnum, u_int8_t * name); /* kicad lib alias add */
extern int ustc_lib_field_add(u_int32_t *fnum, USTC_LIB_FIELD * ulfi); /* kicad lib field add */
extern int ustc_lib_poly_add(u_int32_t *pnum, int32_t x0, int32_t y0); /* kicad lib poly add */
extern int ustc_lib_rect_add(u_int32_t *rnum, USTC_LIB_RECT * ulri); /* kicad lib rect add */
extern int ustc_lib_ring_add(u_int32_t *rnum, USTC_LIB_RING * ulri); /* kicad lib ring add */
extern int ustc_lib_arc_add(u_int32_t *anum, USTC_LIB_ARC * ulai); /* kicad lib arc add */
extern int ustc_lib_text_add(u_int32_t *tnum, USTC_LIB_TEXT * ulti); /* kicad lib text add */
extern int ustc_lib_draw_add(u_int32_t *dnum, USTC_LIB_DRAW * uldi); /* kicad lib draw add */
extern int ustc_lib_pin_add(u_int32_t *pnum, USTC_LIB_PIN * ulpi); /* kicad lib pin add */
extern int ustc_lib_comp_add(u_int32_t *cnum, USTC_LIB_COMP * ulci); /* kicad lib comp add */
extern int ustc_lib_alias_read(u_int32_t * alnum, u_int8_t * buf, u_int32_t size);
extern int ustc_lib_field_read(u_int8_t * fidx, USTC_LIB_FIELD * ulfi, u_int8_t * buf, u_int32_t size);
extern int ustc_lib_poly_read(u_int32_t * pnum, u_int8_t * buf, u_int32_t size,int * pos);
extern int ustc_lib_draw_read(u_int32_t * dnum, u_int32_t * pnum, u_int32_t * rnum,
u_int32_t * rngnum, u_int32_t * anum, u_int32_t * tnum, u_int8_t * buf, u_int32_t size);
extern int ustc_lib_pin_read(u_int32_t * pnum, u_int8_t * buf, u_int32_t size); /* pin read */
extern int ustc_lib_comp_read( u_int32_t * cnum, u_int32_t * alnum,
u_int32_t * flnum, u_int32_t * drnum, u_int32_t * plnum, u_int32_t * rcnum,
u_int32_t * rngnum, u_int32_t * arnum, u_int32_t * txnum, u_int32_t * pnnum, 
u_int8_t * buf, u_int32_t size);
extern int ustc_lib_free(void);
#endif 							/* __USTCLIB_HPP__ */
