#include <stdio.h>			/* */
#include <string.h>			/* */
#include <malloc.h>			/* */
#include <stdlib.h>			/* */
#include <unistd.h>			/* */
#include "ustcio.hpp"
#include "ustcpdsn.hpp"
#define USTCLIB_LICENSE \
"USTCLIB 0.1 (c) 2006-2010 Dmitriy I.Cherkashin, www.ucrouter.ru\r\n"  \
"email: dch@ucrouter.ru , divch@users.sourceforge.net , dch@ucrouter.com\r\n"  \
"phone: +8-909-936-8809; ICQ: 474-363-900;\r\n"  \
"This library is free software with source codes\r\n"  \
"downloadable via internation communicational net.\r\n"  \
"If you have source codes of this software original or modified,\r\n"  \
"you must provide ability to free receive original source codes\r\n"  \
"of this software to another users even in internation communicational\r\n"  \
"net absense without any unusual additional payment exept\r\n" \
"downloading files from internation communicational net cost or\r\n" \
"mail cost.\r\n"
#define USTCLIB_LICENSE_RU \
"USTCLIB 0.1 (c) 2006-2010  ., www.ucrouter.ru\r\n" \
" : dch@ucrouter.ru,divch@users.sourceforge.net,dch@ucrouter.com\r\n"  \
": +8-909-936-8809; ICQ: 474-363-900;\r\n" \
"     \r\n" \
"      \r\n" \
" .\r\n" \
"       \r\n" \
"  ,     \r\n" \
"     \r\n" \
"     \r\n" \
"      \r\n" \
"       \r\n" \
"    \r\n" \
"     .\r\n"
u_int8_t * ustcpdsn_license    = (u_int8_t *)USTCLIB_LICENSE;
u_int8_t * ustcpdsn_license_ru = (u_int8_t *)USTCLIB_LICENSE_RU;
int ustc_padsnet_comp_clear(USTC_PADSNET_COMP * upnci)
{
 if(upnci == 0) {			/* pads net component pointer check */
    return(0);
 }
 upnci->name = 0;			/* component reference */
 upnci->footprint = 0;			/* component footprint */
 return(1);
}
int ustc_padsnet_node_clear(USTC_PADSNET_NODE * upnni)
{
 if(upnni == 0) {			/* pads net node pointer check */
    return(0);
 }
 upnni->type = 0;			/* padsnet node reference type */
 upnni->name.text = 0;			/* component reference text pointer */
 upnni->name.text = 0;			/* component reference text pointer */
 upnni->pin.text = 0;			/* pin number */
 return(1);
}
int ustc_padsnet_signal_clear(USTC_PADSNET_SIGNAL * upnsi) 
{
 if(upnsi == 0) {			/* pads net signal pointer check */
    return(0);
 }
 upnsi->name = 0;			/* padsnet signal name */
 upnsi->node = 0;			/* padsnet node number */
 upnsi->ncount = 0;			/* padsnet node count */
 return(1);
}
int ustc_padsnet_comp_print(USTC_PADSNET_COMP * upnci) /* pads net component print */
{
 if(
    (upnci == 0) ||
    (ustc_fo == 0)			/* null output file pointer */
 ) {
    return(0);
 }
 if(
    (upnci->name == 0) ||		/* component reference */
    (upnci->footprint == 0)		/* component footprint */
 ) {
    return(0);
 }
 if(ustc_space(upnci->name) > 0) {	/* component name space check */
    fprintf(				/* component name quated print */
	ustc_fo,			/* file output descriptor */
	"\"%s\" ",			/* format */
	upnci->name			/* component name */
    );
    if(ustc_space(upnci->footprint) > 0) { /* footrint space character check */
	fprintf(			/* footprint quated print */
	    ustc_fo,			/* output file */
	    "\"%s\"\r\n",		/* format */
	    upnci->footprint		/* footprint name */
	);
    } else {
	fprintf(			/* foortprint print */
	    ustc_fo, 			/* output file */
	    "%s\r\n",			/* format */
	    upnci->footprint		/* foortprint name */
	);
    }
 } else {				/* component name don't contain space */
    if(ustc_space(upnci->footprint) > 0) { /* footprint name space check */
	fprintf(			/* output file print name & quted footprint */
	    ustc_fo, 			/* output file */
	    "%s \"%s\"\r\n",		/* format */
	    upnci->name, 		/* component name */
	    upnci->footprint		/* footprint */
	 );
    } else {
	fprintf(			/* component name & footprint print */
	    ustc_fo, 			/* output file */
	    "%s %s\r\n",		/* format */
	    upnci->name,		/* component name */
	    upnci->footprint		/* footprint */
	 );
    }
 }
 return(1);
}
int ustc_padsnet_node_print(USTC_PADSNET_NODE * upnni)
{
 if(
    (upnni == 0) ||			/* pads net node pointer check */
    (ustc_fo == 0)			/* null output file pointer */
 ) {
    return(0);
 }
 u_int8_t * pnam;			/* component name */
 if((upnni->type & USTC_PADSNET_NODE_NAME_TEXT) > 0) { /* text reference name check */
    pnam = upnni->name.text;		/* component name pointer read */
 } else 
 if((upnni->type & USTC_PADSNET_NODE_NAME_NUM) > 0) { /* number reference check */
    if(upnni->name.num > ustc_padsnet_comp_count) {
	ustc_error(			/* error print */
	    "Node out of padsnet component buffer error,component number {%d},"
	    "component count {%d}\r\n",
	    upnni->name.num,		/* component number */
	    ustc_padsnet_comp_count	/* component count */
	);
	return(0);
    }
    USTC_PADSNET_COMP * upnci;		/* padsnet component pointer */
    upnci = ustc_padsnet_comp + upnni->name.num; /* omponent pointer set */
    pnam = upnci->name;			/* component name print */
 } else {
    ustc_error(				/* error reference print */
        "Node unknown component reference type {%d} error\r\n",
	upnni->type			/* reference type */
    );
    return(0);
 }
 if(ustc_space(pnam) > 0) {		/* component name internal space check */
    fprintf(				/* component name quated print */
        ustc_fo, 			/* output file */
        "\"%s\".",			/* quated name format */
        pnam				/* component name */
    );
 } else {
    fprintf(				/* component name print */
        ustc_fo, 			/* output file */
        "%s.",				/* format */
        pnam				/* component name */
    );
 }    
 if((upnni->type & USTC_PADSNET_NODE_PIN_TEXT) > 0) { /* pin name text check */
    if(ustc_space(upnni->pin.text) > 0) { /* pin name internal space check */	
	fprintf(			/* pin name quated print */
	    ustc_fo, 			/* output file format */
	    "\"%s\"",			/* format quated */
	    upnni->pin.text		/* pin textual name */
	);
    } else {
	fprintf(			/* pin name print */
    	    ustc_fo, 			/* output file */
	    "%s",			/* format */
    	    upnni->pin.text		/* pin text name */
	);
    }    
 } else
 if((upnni->type & USTC_PADSNET_NODE_PIN_NUM) > 0) { /* pin number check */
    fprintf(				/* pin number print */
	ustc_fo, 			/* output file */
	"%d",				/* format */
    	upnni->pin.num			/* pin name */
    );
 } else {
    ustc_error(
        "Node unknown component reference type {%d} error\r\n",
	upnni->type
    );
    return(0);
 }
 return(1);
}
int ustc_padsnet_signal_print(USTC_PADSNET_SIGNAL * upnsi) 
{
 if(
    (upnsi == 0) ||			/* pads net signal pointer check */
    (ustc_fo == 0)			/* null output file pointer */
 ) {
    return(0);
 }
 if(upnsi->name == 0) {			/* signal name pointer check */
    return(0);
 }
 fprintf(ustc_fo,"*SIGNAL* ");
 if(ustc_space(upnsi->name) > 0) {
    fprintf(				/* signal name quated print */
        ustc_fo, 			/* output file */
        "\"%s\"\r\n",			/* signal name quated format */
        upnsi->name			/* signal name */
    );
 } else {
    fprintf(				/* component name print */
        ustc_fo, 			/* output file */
        "%s\r\n",			/* name format */
        upnsi->name			/* signal name */
    );
 }
 int rvl;
 rvl = 1;
 u_int32_t nidx;
 for(nidx = 0; nidx < upnsi->ncount; ++nidx) {
    u_int32_t nnum;
    nnum = upnsi->node + nidx;
    if(nnum >= ustc_padsnet_node_count) {
	ustc_error(
	    "Error, out of node buffer, signale name {%s},"
	    "start node number {%d}, ignal nodes count {%d},"
	    "nodes total count {%d}\r\n",
	    upnsi->name,
	    upnsi->node,
	    upnsi->ncount,
	    ustc_padsnet_node_count
	);
	rvl = 0;
	{ break; }
    }
    USTC_PADSNET_NODE * upnni;
    upnni = ustc_padsnet_node + nnum;
    if(ustc_padsnet_node_print(upnni) == 0) {
	rvl = 0;
    }
    fprintf(ustc_fo," ");
    if(((nidx + 1) % 8) == 0) {
	fprintf(ustc_fo,"\r\n");
    }
 }
 fprintf(ustc_fo,"\r\n");
 return(1);
}
int ustc_padsnet_print(void)		/* pads net print */
{
 if(ustc_fo == 0) {			/* null output file pointer */
    return(0);
 }
 fprintf(				/* file header, parts header print */
    ustc_fo, 				/* output file */
    "*PADS-PCB*\r\n*PART*\r\n"		/* format */
 );
 int rvl;				/* return code */
 rvl = 1;				/* start return code */
 u_int32_t cnum;			/* component number */
 for(cnum = 0; cnum < ustc_padsnet_comp_count; ++cnum) { /* component loop */
    USTC_PADSNET_COMP * upnci;		/* pads net component print */
    upnci = ustc_padsnet_comp + cnum;	/* pads net component pointer set */
    if(ustc_padsnet_comp_print(upnci) == 0) { /* component print */
	rvl = 0;			/* return code clear */
    }
 }
 fprintf(ustc_fo,"\r\n");
 fprintf(ustc_fo,"*NET*\r\n");		/* net header print */
 u_int32_t snum;			/* signal number */
 for(snum = 0; snum < ustc_padsnet_signal_count; ++snum) { /* signal loop */
    USTC_PADSNET_SIGNAL * upnsi;	/* padsnet signal pointer */
    upnsi = ustc_padsnet_signal + snum;	/* padsnet signal pointer set */
    if(ustc_padsnet_signal_print(upnsi) == 0) { /* padsnet signal print */
	rvl = 0;			/* return code clear */
    }
 }
 fprintf(ustc_fo,"*END*\r\n");		/* net header print */
 return(rvl);
}
int ustc_padsnet_comp_alloc(u_int32_t count) /* padsnet componet alloc */
{
 if(count <= ustc_padsnet_comp_count) {	/* padsnet component count check */
    count = ustc_padsnet_comp_count + count; /* padsnet component count calculate */
 }
 USTC_PADSNET_COMP * scomp;		/* buffer pointer saved */
 scomp = ustc_padsnet_comp;		/* buffer pointer save */
 ustc_padsnet_comp = (USTC_PADSNET_COMP *) malloc( /* component buffer allocate */
    sizeof(USTC_PADSNET_COMP) * count	/* component buffer size */
 );
 if(ustc_padsnet_comp == 0) {		/* component buffer allocation check */
    ustc_padsnet_comp = scomp;		/* component buffer pointer restore */
    return(0);
 }
 int rvl;				/* return code */
 rvl = 1;				/* return code start value */
 if(scomp != 0) {
    u_int32_t cnum;			/* component number */
    for(cnum = 0; cnum < ustc_padsnet_comp_count; ++cnum) { /* component loop */
	USTC_PADSNET_COMP * dpnci;	/* destination padsnet component pointer */
	USTC_PADSNET_COMP * spnci;	/* source padsnet component pointer */
	dpnci = ustc_padsnet_comp + cnum; /* destination pointer set */
	spnci = scomp + cnum;		/* source pointer set */
	*dpnci = *spnci;		/* component copy */
    }
    while(cnum < count) {		/* component tail loop */
	USTC_PADSNET_COMP * dpnci;	/* component pointer */
	dpnci = ustc_padsnet_comp + cnum; /* component pointer set */
	cnum += 1;			/* component pointer next number */
	if(ustc_padsnet_comp_clear(dpnci) == 0) { /* component clear */
	    rvl = 0;			/* return code clear */
    	}
    }
 }
 if(scomp != 0) {			/* buffer pointer saved check */
    free(scomp);			/* buffer saved free */
    scomp = 0;				/* saved pointer clear */
 }
 ustc_padsnet_comp_count = count;	/* component write */
 return(rvl);
}
int ustc_padsnet_comp_add(u_int32_t *cnum, u_int8_t * name, u_int8_t * footprint)
{
 if(
    (cnum == 0) ||			/* component number pointer check */
    (name == 0)	||			/* name pointer check */
    (footprint == 0)			/* footprint pointer check */
 ) {
    return(0);
 }
 int rvl; 				/* return code */
 rvl = 1;				/* start return code */
 if(*cnum >= ustc_padsnet_comp_count) {
    if(ustc_padsnet_comp_alloc(100) == 0) {
	rvl = 0;
    }
    if(rvl == 1) {
	if(*cnum >= ustc_padsnet_comp_count) { /* check allocation error */
	    rvl = 0;			/* allocation error */
	}
    }
    if(rvl == 0) {
    	ustc_error("Padsnet comp allocation error\r\n");
	return(0);
    }
 }
 USTC_PADSNET_COMP * dpnci;		/* destination pointer */
 dpnci = ustc_padsnet_comp + *cnum;	/* set destination  pointer */
 int len;				/* buffer length */
 len = strlen((char *)name) + 1;	/* calculate name length */
 dpnci->name = (u_int8_t *) malloc(len); /* allocate buffer name */
 if(dpnci->name == 0) {
    ustc_error("Padsnet component name {%s} allocation error\r\n",
	name
    );
    return(0);
 } else {
    snprintf(				/* padsnet component name form */
	(char *) dpnci->name,		/* padsnet component buffer pointer */
	len,				/* buffer length */
	"%s",				/* format */
	name				/* component name */
    );
 }
 len = strlen((char *)footprint) + 1;	/* footprint length calculate */
 dpnci->footprint = (u_int8_t *) malloc(len); /* allocate buffer name */
 if(dpnci->footprint == 0) {
    ustc_error("Padsnet component footprint {%s} allocation error\r\n",
	name
    );
    return(0);
 } else {
    snprintf(				/* padsnet component footprint name form */
	(char *) dpnci->footprint,	/* footprint name buffer */
	len,				/* buffer length */
	"%s",				/* format */
	footprint
    );
 }
 *cnum += 1;				/* next number */
 return(1);
}
int ustc_padsnet_comp_free(void)	/* padsnet component free */
{
 if(ustc_padsnet_comp != 0) {		/* padsnet component buffer test */
    u_int32_t cnum;			/* component number */ 
    for(cnum = 0; cnum < ustc_padsnet_comp_count; ++cnum) { /* component loop */ 
	USTC_PADSNET_COMP * upnci;	/* component pointer */
	upnci = ustc_padsnet_comp + cnum; /* component pointer set */
	if(upnci->name != 0) {		/* component name pointer test */
	    free(upnci->name);		/* name free */
	    upnci->name = 0;		/* name clear pointer */
	}
	if(upnci->footprint != 0) {	/* component footprint pointer test */
	    free(upnci->footprint);	/* component footprint buffer free */
	    upnci->footprint = 0;	/* component footprint pointer clear */
	}
    }
    free(ustc_padsnet_comp);		/* free buffer */
    ustc_padsnet_comp = 0;		/* clear buffer pointer */
 }
 ustc_padsnet_comp_count = 0;		/* padsnet component buffer clear */
 return(1);
}
int ustc_padsnet_comp_num(u_int8_t * cnam) /* return component number */
{
 if(cnam == 0) {			/* component name pointer check */
    return(-1);				/* component not found */
 }
 u_int32_t cnum;			/* component number */
 for(cnum = 0; cnum < ustc_padsnet_comp_count; ++cnum) { /* component loop */ 
    USTC_PADSNET_COMP * upnci;		/* component pointer */
    upnci = ustc_padsnet_comp + cnum;	/* component pointer set */
    if(upnci->name != 0) {		/* component name pointer test */
	if(strcmp((char *)upnci->name, (char *)cnam) == 0) {
	    return(cnum);		/* return component number */
	}
    }
 }
 return(-1);
}
int ustc_padsnet_comp_read(u_int32_t * cnum, u_int8_t * buf, u_int32_t size)
{
 if(
    (cnum == 0) ||			/* component number test */
    (buf == 0) ||			/* component buffer test */
    (size == 0 )			/* buffer size */
 ) {
    return(0);
 }
 while(1) {
    u_int8_t cut;			/* string cuting */
    cut = 0;				/* catting clear */ 
    int pos;				/* buffer position */
    while(1) {
        if(ustc_read(buf, size, &cut) == 0) {
    	    return(1);
        }
	pos = 0;			/* start buffer position */
	while(*(buf + pos) == ' ' || *(buf + pos) == '\t') { /* tail space skip */
	    pos += 1;			/* buffer position next */
	}
	if(*(buf + pos) == '\0') {	/* empty buffer check */
	    { continue; }		/* next file line read */
	} else
	if(*(buf + pos) == '#') {		/* comment line */
	    { continue; }		/* next read */
	} else {
	    { break; }			/* string readed -> loop exit */
	}
    }
    if(ustc_cmp(buf,"*PADS-PCB*",&pos) != 0) {	/* PADS-PCB header test */
	{ break; }			/* loop exit */
    } else {
        ustc_error(			/* error message print */
	    "Wait *PADS-PCB*, readed {%s}\r\n",  /* format */
    	    buf + pos			/* buffer */
        );
        return(0);
    }
 }
 while(1) {
    u_int8_t cut;			/* string cuting */
    cut = 0;				/* catting clear */ 
    int pos;				/* buffer position */
    while(1) {
        if(ustc_read(buf, size, &cut) == 0) {
    	    return(1);
	}
	pos = 0;			/* start buffer position */
	while(*(buf + pos) == ' ' || *(buf + pos) == '\t') { /* tail space skip */
	    pos += 1;			/* buffer position next */
	}
	if(*(buf + pos) == '\0') {	/* empty buffer check */
	    { continue; }		/* next file line read */
	} else
	if(*(buf + pos) == '#') {	/* comment line */
	    { continue; }		/* next read */
	} else {
	    { break; }			/* string readed -> loop exit */
	}
    }
    pos = 0;				/* start buffer position */
    if(ustc_cmp(buf,"*PART*", &pos) > 0) {
	break;
    } else {
        ustc_error(			/* error message print */
	    "Wait *PART*, readed {%s}\r\n", /* format */
    	    buf				/* buffer */
        );
        return(0);
    }
 }
 int rvl;				/* return code */
 rvl = 1; 				/* start return code */
 while(1) {
    u_int8_t cut;			/* string cuting */
    cut = 0;				/* catting clear */ 
    while(1) {
        if(ustc_read(buf, size, &cut) == 0) { /* file line read */
    	    return(rvl);
	}
	if(*(buf + 0) == '\0') {	/* empty buffer check */
	    { continue; }		/* next file line read */
	} else {
	    { break; }		/* string readed -> loop exit */
	}
    }
    int pos;				/* buffer position */
    pos = 0;				/* start buffer position */
    if(*(buf + 0) == '#') {		/* comment line */
	{ continue; }			/* next read */
    }
    if(ustc_cmp(buf,"*NET*", &pos) > 0) { /* string terminating check */
	{ break; }			/* loop exit */
    }
    USTC_PADSNET_COMP upnci;		/* padsnet component */	
    if(ustc_padsnet_comp_clear(&upnci) == 0) { /* padsnet component clear */
	ustc_error("Padsnet component clear error\r\n");
	return(0);
    }
    u_int8_t name[128];			/* name buffer */
    u_int8_t srd;			/* string reading */
    cut = 0;				/* clear name cuting */
    srd = 0;				/* readed value */
    if(ustc_str(buf, name, size, &pos, &cut, &srd) == 0) {
	ustc_error(			/* error message */
	    "Padnet component name read error {%s}\r\n",  /* format */
	    buf + pos			/* buffer */
	);
	return(0);
    } else {
        if(srd == 0) {			/* readed check */
	    ustc_error("Padsnet component name {%s} read error\r\n", 
		buf
	    );
	    return(0);
        }
    }
    u_int8_t footprint[128];		/* footprint buffer */
    size = sizeof(footprint);
    cut = 0;				/* clear footprint cuting */
    srd = 0;				/* readed value */
    if(ustc_str(buf, footprint, size, &pos, &cut, &srd) == 0) {
	ustc_error("Padnet component footrint {%s} read error\r\n", 
	    buf + pos
	);
	return(0);
    } else {
        if(srd == 0) {
	    ustc_error("Padsnet component footrint {%s} read error\r\n", 
		buf
	    );
	    return(0);
        }
    }
    if(ustc_padsnet_comp_add(		/* padsnet component add */
	cnum, 				/* component number */
	name, 				/* component name */
	footprint			/* component footprint */
    ) == 0) {
	if(rvl == 1) {
	    ustc_error("Padsnet component {%s} add error\r\n", 
		name
	    );
	    rvl = 0;
	}
    }
 }
 return(rvl);
}
int ustc_padsnet_node_alloc(u_int32_t count) /* padsnet node alloc */
{
 if(count <= ustc_padsnet_node_count) {	/* padsnet node count check */
    count = ustc_padsnet_node_count + count; /* padsnet node count calculate */
 }
 USTC_PADSNET_NODE * snode;		/* buffer pointer saved */
 snode = ustc_padsnet_node;		/* buffer pointer save */
 ustc_padsnet_node = (USTC_PADSNET_NODE *) malloc( /* node buffer allocate */
    sizeof(USTC_PADSNET_NODE) * count	/* node buffer size */
 );
 if(ustc_padsnet_node == 0) {		/* node buffer allocation check */
    ustc_padsnet_node = snode;		/* node buffer pointer restore */
    return(0);
 }
 int rvl;				/* return code */
 rvl = 1;				/* return code start value */
 if(snode != 0) {
    u_int32_t nnum;			/* node number */
    for(nnum = 0; nnum < ustc_padsnet_node_count; ++nnum) { /* node loop */
	USTC_PADSNET_NODE * dpnni;	/* destination padsnet node pointer */
	USTC_PADSNET_NODE * spnni;	/* source padsnet node pointer */
	dpnni = ustc_padsnet_node + nnum; /* destination pointer set */
	spnni = snode + nnum;		/* source pointer set */
	*dpnni = *spnni;		/* node copy */
    }
    while(nnum < count) {		/* node tail loop */
	USTC_PADSNET_NODE * dpnni;	/* node pointer */
	dpnni = ustc_padsnet_node + nnum; /* node pointer set */
	nnum += 1;			/* node pointer next number */
	if(ustc_padsnet_node_clear(dpnni) == 0) { /* node clear */
	    rvl = 0;			/* return code clear */
    	}
    }
 }
 if(snode != 0) {			/* buffer pointer saved check */
    free(snode);			/* buffer saved free */
    snode = 0;				/* saved pointer clear */
 }
 ustc_padsnet_node_count = count;	/* node write */
 return(rvl);
}
int ustc_padsnet_node_add(u_int32_t *nnum, u_int8_t * cname, u_int32_t cnum,
u_int8_t * pname, u_int32_t pnum)
{
 if(
    (nnum == 0) ||			/* node number pointer check */
    ((cname == 0) && (cnum == (u_int32_t)(-1))) || /* component name & component number check */
    ((pname == 0) && (pnum == (u_int32_t)(-1))) /* pin name & pin number check */
 ) {
    return(0);
 }
 int rvl; 				/* return code */
 rvl = 1;				/* start return code */
 if(*nnum >= ustc_padsnet_node_count) {
    if(ustc_padsnet_node_alloc(100) == 0) {
	rvl = 0;
    }
    if(rvl == 1) {
	if(*nnum >= ustc_padsnet_node_count) { /* check allocation error */
	    rvl = 0;			/* allocation error */
	}
    }
    if(rvl == 0) {
    	ustc_error("Padsnet node allocation error\r\n");
	return(0);
    }
 }
 USTC_PADSNET_NODE * dpnni;		/* destination pointer */
 dpnni = ustc_padsnet_node + *nnum;	/* set destination  pointer */
 dpnni->type = 0;			/* padsnet node reference type clear */
 if(cname != 0) {			/* component name check */
    int len;				/* component name length */
    len = strlen((char *)cname) + 1;	/* component name length calculate */
    dpnni->name.text = (u_int8_t *) malloc(len); /* allocate buffer name */
    if(dpnni->name.text == 0) {
	ustc_error("Padsnet node component name {%s} allocation error\r\n",
	    cname
	);
	return(0);
    } else {
	snprintf(			/* padsnet node name form */
	    (char *) dpnni->name.text,	/* padsnet node buffer pointer */
	    len,			/* buffer length */
	    "%s",			/* format */
	    cname			/* node name */
	);
    }
    dpnni->type |= USTC_PADSNET_NODE_NAME_TEXT; /* text reference */
 } else {
    dpnni->name.num = cnum;		/* number reference write */
    dpnni->type |= USTC_PADSNET_NODE_NAME_NUM; /* number reference */
 }
 if(pname != 0) {
    int len;				/* buffer length */
    len = strlen((char *)pname) + 1;	/* calculate pin name length */
    dpnni->pin.text = (u_int8_t *) malloc(len); /* allocate buffer name */
    if(dpnni->pin.text == 0) {
	ustc_error("Padsnet node pin name {%s} allocation error\r\n",
	    pname
	);
	return(0);
    } else {
	snprintf(			/* padsnet node name form */
	    (char *) dpnni->pin.text,	/* padsnet node buffer pointer */
	    len,			/* buffer length */
	    "%s",			/* format */
	    pname			/* node name */
	);
    }
    dpnni->type |= USTC_PADSNET_NODE_PIN_TEXT; /* text reference */
 } else {
    dpnni->pin.num = pnum;		/* pin number reference write */
    dpnni->type |= USTC_PADSNET_NODE_PIN_NUM; /* number reference */
 }
 *nnum += 1;				/* next number */
 return(1);
}
int ustc_padsnet_node_free(void)	/* padsnet node free */
{
 if(ustc_padsnet_node != 0) {		/* padsnet node buffer test */
    u_int32_t nnum;			/* node number */ 
    for(nnum = 0; nnum < ustc_padsnet_node_count; ++nnum) { /* node loop */ 
	USTC_PADSNET_NODE * upnci;	/* node pointer */
	upnci = ustc_padsnet_node + nnum; /* node pointer set */
	if((upnci->type & USTC_PADSNET_NODE_NAME_TEXT) != 0) {
	    if(upnci->name.text != 0) {	/* node name pointer test */
		free(upnci->name.text);	/* name free */
		upnci->name.text = 0;	/* name clear pointer */
	    }
	}
	if((upnci->type & USTC_PADSNET_NODE_PIN_TEXT) != 0) {
	    if(upnci->pin.text != 0) {	/* node name pointer test */
		free(upnci->pin.text);	/* name free */
		upnci->pin.text = 0;	/* name clear pointer */
	    }
	}
    }
    free(ustc_padsnet_node);		/* free buffer */
    ustc_padsnet_node = 0;		/* clear buffer pointer */
 }
 ustc_padsnet_node_count = 0;		/* padsnet node buffer clear */
 return(1);
}
int ustc_padsnet_signal_alloc(u_int32_t count) /* padsnet signal alloc */
{
 if(count <= ustc_padsnet_signal_count) {	/* padsnet signal count check */
    count = ustc_padsnet_signal_count + count; /* padsnet signal count calculate */
 }
 USTC_PADSNET_SIGNAL * ssignal;		/* buffer pointer saved */
 ssignal = ustc_padsnet_signal;		/* buffer pointer save */
 ustc_padsnet_signal = (USTC_PADSNET_SIGNAL *) malloc( /* signal buffer allocate */
    sizeof(USTC_PADSNET_SIGNAL) * count	/* signal buffer size */
 );
 if(ustc_padsnet_signal == 0) {		/* signal buffer allocation check */
    ustc_padsnet_signal = ssignal;		/* signal buffer pointer restore */
    return(0);
 }
 int rvl;				/* return code */
 rvl = 1;				/* return code start value */
 if(ssignal != 0) {
    u_int32_t snum;			/* signal number */
    for(snum = 0; snum < ustc_padsnet_signal_count; ++snum) { /* signal loop */
	USTC_PADSNET_SIGNAL * dpnsi;	/* destination padsnet signal pointer */
	USTC_PADSNET_SIGNAL * spnsi;	/* source padsnet signal pointer */
	dpnsi = ustc_padsnet_signal + snum; /* destination pointer set */
	spnsi = ssignal + snum;		/* source pointer set */
	*dpnsi = *spnsi;		/* signal copy */
    }
    while(snum < count) {		/* signal tail loop */
	USTC_PADSNET_SIGNAL * dpnsi;	/* signal pointer */
	dpnsi = ustc_padsnet_signal + snum; /* signal pointer set */
	snum += 1;			/* signal pointer next number */
	if(ustc_padsnet_signal_clear(dpnsi) == 0) { /* signal clear */
	    rvl = 0;			/* return code clear */
    	}
    }
 }
 if(ssignal != 0) {			/* buffer pointer saved check */
    free(ssignal);			/* buffer saved free */
    ssignal = 0;			/* saved pointer clear */
 }
 ustc_padsnet_signal_count = count;	/* signal write */
 return(rvl);
}
int ustc_padsnet_signal_add(u_int32_t *snum, USTC_PADSNET_SIGNAL * upnsi)
{
 if(
    (snum == 0) ||			/* signal number pointer check */
    (upnsi == 0)			/* signal pointer null check */
 ) {
    return(0);
 }
 int rvl; 				/* return code */
 rvl = 1;				/* start return code */
 if(*snum >= ustc_padsnet_signal_count) {
    if(ustc_padsnet_signal_alloc(100) == 0) {
	rvl = 0;
    }
    if(rvl == 1) {
	if(*snum >= ustc_padsnet_signal_count) { /* check allocation error */
	    rvl = 0;			/* allocation error */
	}
    }
    if(rvl == 0) {
    	ustc_error("Padsnet signal allocation error\r\n");
	return(0);
    }
 }
 USTC_PADSNET_SIGNAL * dpnsi;		/* destination pointer */
 dpnsi = ustc_padsnet_signal + *snum;	/* set destination  pointer */
 *dpnsi = *upnsi;			/* padsnet sinal copy */
 *snum += 1;				/* next number */
 return(1);
}
int ustc_padsnet_signal_free(void)	/* padsnet signal free */
{
 if(ustc_padsnet_signal != 0) {		/* padsnet signal buffer test */
    u_int32_t snum;			/* signal number */ 
    for(snum = 0; snum < ustc_padsnet_signal_count; ++snum) { /* signal loop */ 
	USTC_PADSNET_SIGNAL * upnsi;	/* signal pointer */
	upnsi = ustc_padsnet_signal + snum; /* signal pointer set */
	if(upnsi->name != 0) {		/* signal name pointer test */
	    free(upnsi->name);		/* name free */
	    upnsi->name = 0;		/* name clear pointer */
	}
    }
    free(ustc_padsnet_signal);		/* free buffer */
    ustc_padsnet_signal = 0;		/* clear buffer pointer */
 }
 ustc_padsnet_signal_count = 0;		/* padsnet signal buffer clear */
 return(1);
}
int ustc_padsnet_free(void)
{
 int rvl;
 rvl = 1;
 if(ustc_padsnet_comp_free() == 0) {	/* padsnet component free */
    rvl = 0;				/* return code clear */
 }
 if(ustc_padsnet_node_free() == 0) {	/* padsnet node free */
    rvl = 0;				/* return code clear */
 }
 if(ustc_padsnet_signal_free() == 0) {	/* padsnet signal free */
    rvl = 0;				/* return code clear */
 }
 return(rvl);
}
int ustc_padsnet_signal_read(u_int32_t * snum, u_int32_t * nnum, 
u_int8_t * buf, u_int32_t size)
{
 if(
    (snum == 0) ||			/* signal number pointer null check */
    (nnum == 0) ||			/* node number pointer null check */
    (buf == 0) ||			/* component buffer test */
    (size == 0 )			/* buffer size */
 ) {
    return(0);
 }
 while(1) {
    int pos;			/* buffer position */
    u_int8_t cut;			/* string cuting */
    pos = 0;			/* start buffer position */
    cut = 0;			/* catting clear */ 
    if(*(buf + pos) == '\0') {	/* empty string check */
        if(ustc_read(buf, size, &cut) == 0) {
	    return(1);
	}
    }
    while(				/* head space skip */
        (*(buf + pos) == ' ') || 	/* space character test */
        (*(buf + pos) == '\t')	/* tab character test */
    ) {
        pos += 1;			/* buffer position next */
    }
    if(*(buf + pos) == '\0') {	/* empty buffer check */
        { continue; }		/* next file line read */
    } else
    if(*(buf + pos) == '#') {	/* comment line */
        { continue; }		/* next read */
    } else 
    if(ustc_cmp(buf,"*NET*", &pos) != 0) {
        { break; }			/* loop exit */
    } else {
        ustc_error(
    	    "Read error, wait *NET*, readed {%s}\r\n",
    	    buf + pos
	);
        return(0);
    }
 }
 *(buf + 0) = '\0';			/* buffer clear */
 int rvl;				/* return code */
 rvl = 1; 				/* return code start */
 while(1) {
    u_int8_t cut;			/* string cuting */
    cut = 0;				/* catting clear */ 
    while(1) {
	if(*(buf + 0) == '\0') {
	    if(ustc_read(buf, size, &cut) == 0) { /* file line read */
    		return(rvl);
	    }
	}
	if(*(buf + 0) == '\0') {	/* empty buffer check */
	    { continue; }		/* next file line read */
	} else {
	    { break; }			/* string readed -> loop exit */
	}
    }
    if(*(buf + 0) == '#') {		/* comment line */
	*(buf + 0) = '\0';		/* buffer clear */
	{ continue; }			/* next read */
    }
    int pos;				/* buffer position */
    pos = 0;				/* start buffer position */
    if(ustc_cmp(buf,"*END*", &pos) > 0) {
	{ break; }
    } else
    if(ustc_cmp(buf,"*SIGNAL*", &pos) == 0) { /* string terminating check */
	if(rvl == 1) {
	    ustc_error(			/* error message print */
		"Wait *SIGNAL*, readed {%s}\r\n", /* format */
		buf + pos
	    );
	    rvl = 0;
	}
	{ break; }			/* loop exit */
    }
    USTC_PADSNET_SIGNAL upnsi;		/* padsnet signal */
    if(ustc_padsnet_signal_clear(&upnsi) == 0) { /* padsnet signal clear */
	ustc_error(			/* error message print */
	    "Padsnet signal clear error\r\n" /* format */
	);
	return(0);
    }
    u_int8_t name[128];			/* name buffer */
    u_int8_t srd;			/* string reading */
    cut = 0;				/* clear name cuting */
    srd = 0;				/* readed value */
    if(ustc_str(buf, name, size, &pos, &cut, &srd) == 0) {
	ustc_error(			/* error message */
	    "Padnet signal name read error {%s}\r\n",  /* format */
	    buf + pos			/* buffer */
	);
	return(0);
    } else {
        if(srd == 0) {			/* readed check */
	    ustc_error("Padsnet component name {%s} read error\r\n", 
		buf
	    );
	    return(0);
        } else {
	    int len;			/* signal name length */
	    len = strlen((char *) name) + 1; /* signal name length calculate */
	    upnsi.name = (u_int8_t *) malloc(len); /* signal name allocation */
	    if(upnsi.name == 0) {	/* signal name allocation check */
		ustc_error(		/* error message print */
		    "Padsnet signal name {%s} allocation error\r\n", 
		    name		/* signal name */
		);
		return(0);		
	    } else {
		snprintf(		/* signame name form */
		    (char *) upnsi.name, /* signal name buffer */
		    len,		/* signal name buffer length */
		    "%s",		/* format */
		    name		/* signal name */
		);
	    }
	}
    }
    upnsi.node = *nnum;			/* signal node number */
    upnsi.ncount = 0;			/* signal node count */
    while(1) {
	if(ustc_read(buf, size, &cut) == 0) { /* file line read */
    	    { break; }			/* loop exit */
        }
	if(*(buf + 0) == '\0') {	/* empty buffer check */
	    { continue; }		/* next file line read */
	}
	pos = 0;
	if(
	    (ustc_cmp(buf,"*SIGNAL*", &pos) > 0) || /* string terminating check */
	    (ustc_cmp(buf,"*END*", &pos) > 0)
	) { 
	    { break; }			/* loop exit */
	}
        u_int32_t dpos;			/* destination position */
	u_int8_t cnam[128];		/* component name */
	u_int8_t pnam[128];		/* pin name */
	pos = 0;			/* buffer position */
	while(1) {			/* component name & pin name extract loop */
	    if(pos >= (int)size) {	/* out of buffer */
		{ break; }		/* loop exit */
	    } 
	    while(*(buf + pos) == ' ') { /* head spaces skip */
		pos += 1;		/* buffer position next */
	    }
	    if(*(buf + pos) == '\0') {	/* termianting character check */
		{ break; }		/* loop exit */
	    }
	    dpos = 0;			/* destination position */
	    while((*(buf + pos) != '\0') && (*(buf + pos) != '.')) { /* component name read */
		if(dpos < sizeof(cnam)) {	/* destination position check */
		    cnam[dpos] = buf[pos];  /* character copy */
		}
		dpos += 1;		/* destination position next */
		pos += 1;		/* source position next */
	    }
	    if(dpos >= sizeof(cnam)) {	/* componet buffer out of cehck */
		dpos = sizeof(cnam) - 1; /* end buffer position */
	    }
	    cnam[dpos] = '\0';		/* component name termibating character */
	    if(*(buf + pos) == '.') {	/* separator check */
		dpos = 0;		/* destination position start */
		pos += 1; 		/* source position start */
		while((*(buf + pos) != '\0') && (*(buf + pos) != ' ')) {
		    if(dpos < sizeof(pnam)) {
			pnam[dpos] = *(buf + pos);
		    }
		    dpos += 1;		/* destination postion next */
		    pos += 1;		/* source position next */
		}
		if(dpos >= sizeof(pnam)) { /* pin name buffer out of check */
		    dpos = sizeof(pnam) - 1; /* pin name b uffer end character */
		}
		pnam[dpos] = '\0';	/* pin name terminating character */
	    } else {
		if(rvl == 1) {		/* return code check */
    		    ustc_error(		/* error message print */
			"Padsnet signal pin name {%s} read error\r\n", /* format */
			buf + pos	/* buffer */
		    );
		    rvl = 0;
		}
    	    }
	    while(pos < (int)size) {
		if(*(buf + pos) == ' ') { /* head spaces skip */
		    pos += 1;		/* buffer position next */
		} else {
		    { break; }		/* loop exit */ 
		}
	    }
	    u_int32_t cnum;		/* component number */
	    cnum = ustc_padsnet_comp_num(cnam); /* component number calc */
	    u_int8_t * cptr;
	    u_int8_t * pptr;
	    if(cnum != (u_int32_t)(-1)) {
		cptr = 0;
	    } else {
		cptr = cnam;
	    }
	    u_int32_t pnum;		/* pin number */
	    pnum = (u_int32_t)(-1);	/* pin number start */
	    pptr = pnam;
    	    dpos = 0;			/* pin number position */
	    while(dpos < sizeof(pnam)) { /* pin name loop */
		if(pnam[dpos] == '\0') {
		    pnum = atoi((char *)pnam); /* pin number calculate */
		    pptr = 0;
		    { break; }		/* loop exit */
		} else
		if((pnam[dpos] < '0') || (pnam[dpos] > '9')) {
		    { break; }		/* not digit -> loop exit */
	        }
		dpos += 1;		/* pin position next */
	    }
	    if(ustc_padsnet_node_add(	/* node add */
    		nnum,			/* node number */
		cptr,			/* component name */
		cnum,			/* component number */
		pptr,			/* pin name */
		pnum			/* pin number */
	    ) == 0) {
    		if(rvl == 1) {		/* return code check */
    		    ustc_error("Padsnet signal {%s} node add error\r\n", 
			upnsi.name	/* signal name */
		    );	
		    rvl = 0;		/* return code clear */
		}
	    }
	}
    }
    upnsi.ncount = (*nnum - upnsi.node); /* signal node count */
    if(ustc_padsnet_signal_add(		/* signal add */
        snum,				/* signal number */
        &upnsi				/* signal pointer */
    ) == 0) {
        if(rvl == 1) {
    	    ustc_error("Padsnet signal {%s} add error\r\n", 
	        upnsi.name
	    );
	    rvl = 0;
	}
    }
 }
 return(rvl);
}
int ustc_padsnet_read(void)
{
 int rvl;				/* return code */
 rvl = 1;
 u_int8_t buf[512];			/* buffer */
 u_int32_t size;			/* buffer size */
 u_int32_t cnum;			/* component number */
 u_int32_t snum;			/* signal number */
 u_int32_t nnum;			/* node number */
 size = sizeof(buf);			/* buffer size calculate */
 buf[0] = '\0';				/* buffer read */
 cnum = ustc_padsnet_comp_count;	/* component number start */
 snum = ustc_padsnet_signal_count;	/* signal number start */
 nnum = ustc_padsnet_node_count;	/* node number start */
 if(ustc_padsnet_comp_read(		/* component read */
    &cnum, 				/* component number pointer */
    buf,				/* buffer */
    size				/* buffer size */
 ) == 0) { 
    ustc_error(				/* print error message */
	"Padsnet components read error\r\n");
    rvl = 0;				/* return code clear */
 }
 if(rvl == 1) {
    if(ustc_padsnet_signal_read(	/* signal read */
	&snum,				/* signal number pointer */
	&nnum, 				/* node number pointer */
	buf,				/* buffer */
	size				/* buffer size */
    ) == 0) { 
	if(rvl == 1) {			/* return code check */
	    ustc_error("Padsnet nets read error\r\n"); /* error message print */
	    rvl = 0;			/* return code clear */
	}
    }
 }
 ustc_padsnet_comp_count = cnum;	/* component count write */
 ustc_padsnet_signal_count = snum;	/* signal count write */
 ustc_padsnet_node_count = nnum;	/* node count write */
 return(rvl);
}

